/*
 * Copyright (c) 2005-2013, BearWare.dk
 * 
 * Contact Information:
 *
 * Bjoern D. Rasmussen
 * Bedelundvej 79
 * DK-9830 Taars
 * Denmark
 * Email: contact@bearware.dk
 * Phone: +45 20 20 54 59
 * Web: http://www.bearware.dk
 *
 * This source code is part of the TeamTalk 4 SDK owned by
 * BearWare.dk. All copyright statements may not be removed 
 * or altered from any source distribution. If you use this
 * software in a product, an acknowledgment in the product 
 * documentation is required.
 *
 */

#ifndef VIDEOGRIDWIDGET_H
#define VIDEOGRIDWIDGET_H

#include "gridwidget.h"

#include "uservideowidget.h"

class VideoGridWidget : public GridWidget
{
    Q_OBJECT

public:
    VideoGridWidget(QWidget * parent);

    int getUserStreamID(int userid) const;


signals:
    void userVideoSelected(bool selected);
    void userVideoEnded(int userid);

    void videoCountChanged(int);

protected:
    QString getEmptyGridText() const;

public slots:
    void slotAddUser(int userid, int streamid);
    void slotRemoveUser(int userid, int);
    void slotNewVideoFrame(int userid, int frame_count);

    void slotVideoWidgetFocused(int userid, bool focused);
};

#endif /* VIDEOGRIDWIDGET_H */
